/*
* Copyright (c) 2005 X.Org Foundation LLC
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
* 
* Copyright (c) Applied Testing and Technology, Inc. 1993, 1994, 1995
* Copyright (c) 88open Consortium, Ltd. 1990, 1991, 1992, 1993
* All Rights Reserved.
* 
*/
/*
 * SYNOPSIS:
 *   Boolean
 *   XtIsOverrideShell()
 */


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <XtTest.h>

/*error messages created here*/
char	ebuf[4096];
/*allows a test to extend how long it runs*/
int	xt_tomultiple = 1;

XtAppContext app_ctext;
Widget topLevel, panedw, boxw1, boxw2;
Widget labelw, rowcolw, click_quit;


#define T_XtIsOverrideShell	1
char    *TestName = "XtIsOverrideShell";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

static void t001(){

Boolean status;
Widget menuw;
pid_t	pid;

 	report_purpose(1);

	report_assertion("Assertion XtIsOverrideShell-1.(A)");
	report_assertion("A call to Boolean XtIsOverrideShell(w) when the class of");
	report_assertion("the widget w is equal to or is a subclass of the");
	report_assertion("OverrideShell widget class shall return True.");
	FORK(pid);
	initconfig();

	avs_xt_hier("Tisovrrdsh1", "XtIsOverrideShell");
	tet_infoline("PREP: Create Menu Shell widget menuw");
	menuw = (Widget) CreateMenuShellWidget(topLevel);
	tet_infoline("PREP: Create windows for widgets and map them");
	XtRealizeWidget(topLevel);
	tet_infoline("TEST: Returns True if subclass of Override Shell");
	status = XtIsOverrideShell(menuw);
	check_dec(True, status, "Return value");
	tet_result(TET_PASS);

	LKROF(pid, AVSXTTIMEOUT*xt_tomultiple);
}

/* Including from file Mdefcode.tmc.10796 */
/* End of included file Mdefcode.tmc.10796 */

static void t002(){

Boolean status;
pid_t	pid;

 	report_purpose(2);

	report_assertion("Assertion XtIsOverrideShell-2.(A)");
	report_assertion("A call to Boolean XtIsOverrideShell(w) when the class of");
	report_assertion("the widget w is neither equal to nor is a subclass of the");
	report_assertion("OverrideShell widget class shall return a value other than");
	report_assertion("True.");
	FORK(pid);
	initconfig();

	avs_xt_hier("Tisoversh2", "XtIsOverrideShell");
	tet_infoline("PREP: Create windows for widgets and map them");
	XtRealizeWidget(topLevel);
	tet_infoline("TEST: Returns non-True if not equal to or subclass of Override Shell");
	status = XtIsOverrideShell(labelw);
	check_not_dec(True, status, "Return value");
	tet_result(TET_PASS);

	LKROF(pid, AVSXTTIMEOUT*xt_tomultiple);
}

/* Including from file Mdefcode.tmc.10796 */
/* End of included file Mdefcode.tmc.10796 */

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	{ t001, 1 },
	{ t002, 2 },
	{ NULL, 0 }
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = NULL;
void	(*tet_cleanup)() = NULL;
