/*
* Copyright (c) 2005 X.Org Foundation LLC
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
* 
* Copyright (c) Applied Testing and Technology, Inc. 1993, 1994, 1995
* Copyright (c) 88open Consortium, Ltd. 1990, 1991, 1992, 1993
* All Rights Reserved.
* 
*/
/*
 * SYNOPSIS:
 *   XtAppContext
 *   XtWidgetToApplicationContext()
 */


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <XtTest.h>

/*error messages created here*/
char	ebuf[4096];
/*allows a test to extend how long it runs*/
int	xt_tomultiple = 1;

#include <X11/IntrinsicP.h>
#include <X11/ConstrainP.h>
#include <X11/CoreP.h>

XtAppContext app_ctext;
Widget topLevel, panedw, boxw1, boxw2;
Widget labelw, rowcolw, click_quit;


#define T_XtWidgetToApplicationContext	1
char    *TestName = "XtWidgetToApplicationContext";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

static void t001(){

XtAppContext app_ctext_ret;
pid_t	pid;

 	report_purpose(1);

	report_assertion("Assertion XtWidgetToApplicationContext-1.(A)");
	report_assertion("A call to XtAppContext XtWidgetToApplicationContext(w)");
	report_assertion("shall return the application context of the widget w.");
	FORK(pid);
	initconfig();

	avs_xt_hier("Twdgttappl1", "XtWidgetToApplicationContext");
	tet_infoline("PREP: Create windows for widgets and map them");
	XtRealizeWidget(topLevel);
	tet_infoline("TEST: Returns widget's application context");
	app_ctext_ret = XtWidgetToApplicationContext(topLevel);
	if (app_ctext_ret == NULL) {
	  	tet_infoline("ERROR: Expected valid application context returned NULL");
		tet_result(TET_FAIL);
	}
	if (app_ctext_ret != app_ctext) {
	  	tet_infoline("ERROR: Incorrect application context returned");
		tet_result(TET_FAIL);
	}

	app_ctext_ret = XtWidgetToApplicationContext(labelw);
	if (app_ctext_ret == NULL) {
	  	tet_infoline("ERROR: Expected valid application context returned NULL");
		tet_result(TET_FAIL);
	}

	if (app_ctext_ret != app_ctext) {
	  	tet_infoline("ERROR: Incorrect application context returned");
		tet_result(TET_FAIL);
	}
	tet_result(TET_PASS);

	LKROF(pid, AVSXTTIMEOUT*xt_tomultiple);
}

/* Including from file Mdefcode.tmc.10961 */
/* End of included file Mdefcode.tmc.10961 */

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	{ t001, 1 },
	{ NULL, 0 }
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = NULL;
void	(*tet_cleanup)() = NULL;
